require "raygun/apm/rails/version"

module Raygun
  module Apm
    module Rails
      class Error < StandardError; end

        # from https://api.rubyonrails.org/ , to automate
        BLACKLIST = %w{
          #<ActiveRecord
          #<ActiveModel
          Benchmark#
          Benchmark::
          BigDecimal#
          Benchmark::
          Concurrent#
          Concurrent::
          Date#
          Date::
          DateAndTime#
          DateAndTime::
          DateTime#
          DateTime::
          Delegator#
          Digest#
          Digest::
          SecureRandom#
          SecureRandom::
          AbstractController
          ActionCable
          ActionController
          ActionDispatch
          ActionMailbox
          ActionMailer
          ActionText
          ActionView
          ActiveJob
          ActiveModel
          ActiveRecord
          ActiveStorage
          ActiveSupport
          Arel
          Mail#
          Mail::
          Mime#
          Mime::
          Rails
          Rack
          I18n
          Bootsnap
          Sprockets
          Turbolinks
          Pathname
          MonitorMixin
          Logger
          Sprockets
          ActionDispatch
          ActiveSupport
          ActionView
          SQLite3
          Mysql2
          Erubi
          RequestStore
          WEBrick
          Puma
          PG
          EnabledModule
          ConnectionPool
          CoffeeScript
          ApplicationRecord
          Zeitwerk
          SassC
          Webpacker
          DidYouMean
          Nokogiri
          Loofah
          WebConsole
          HTTParty
          TZInfo
          Devise
          Marginalia
          FastGettext
          Lograge
          Warden
          Grape
          Mustermann
          Enumeration
          +Raygun::Apm::Rails::Middleware#Ruby_APM_profiler_trace
          WebpackHelper
          Ripper
          Webpack
          AfterCommitQueue
          Hamlit
          __callbacks
          _reflections
          attribute_aliases
          default_scope_override
          _routes
          table_name_prefix
          _validators
          attribute_type_decorations
          middleware_stack
          _helpers
          _layout
          updated_at_before_type_cast
          created_at_before_type_cast
          _include_layout?
          after_remove_for_
          before_remove_for_
          before_add_for_
          after_add_for_
          autosave_associated_records_for_
          validate_associated_records_for_
          will_save_change_to_
          +ActiveStorage::Blob#upload
          +ActiveStorage::Blob#download
          +ActiveStorage::DiskController#show
          +ActiveStorage::DiskController#update
          +ActiveStorage::DirectUploadsController#create
          +ActiveStorage::BlobsController#show
          +ActiveStorage::RepresentationsController#show
        }

        def self.raygun4ruby?(configured = true)
          if configured
            defined?(Raygun) && Raygun.respond_to?(:configured?) && Raygun.configured?
          else
            defined?(Raygun) && Raygun.respond_to?(:configured?)
          end
        end
    end
  end
end

if defined?(::Rails) && !ENV['RAYGUN_SKIP_MIDDLEWARE']
  require "raygun/apm/rails/railtie"
end
