module Raygun
  module Apm
    module Rails
      class Railtie < ::Rails::Railtie
        initializer "raygun.apm.rails" do |app|
          require "raygun/apm"
          require "raygun/apm/rails/middleware"
          Raygun::Apm::Blacklist.extend_with Raygun::Apm::Rails::BLACKLIST
          if Raygun::Apm::Rails.raygun4ruby?(false)
            # Remove the exception notifier because we handle it in the APM middleware now instead
            app.middleware.delete Raygun::Middleware::RackExceptionInterceptor
          end
          app.middleware.use Raygun::Apm::Rails::Middleware
          # Explictly enable instrumenting HTTP until a good control API is figured out
          require "raygun/apm/hooks/net_http"
          require "raygun/apm/hooks/redis" if defined?(Redis::Client)
        end
      end
    end
  end
end
